﻿/*
 * Written by Stewart Berman 2012
 * Please send any bug reports / suggestions to sab@saberman.com
 * 
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ODBC
{
    class clsODBCReferences
    {
        private static readonly clsODBCReferences _instance = new clsODBCReferences();

        public const int connFUNCTION_MAX = 100;
        public const int connFUNCTION_USED = 72;

        public UInt32[] nFunctions = new UInt32[connFUNCTION_MAX + 1];
        public string[] sFunctions = new String[connFUNCTION_MAX + 1];

        const int connINFORMATION_MAX = 1000;
        const int connINFORMATION_USED = (int)ODBCconst.SQL_INFO_LAST;

        public UInt32[] nInformation = new UInt32[connINFORMATION_MAX + 1];
        public string[] sInformation = new string[connINFORMATION_MAX + 1];

        private clsODBCReferences()
        {
            sFunctions[1] = "SQLAllocConnect";
            sFunctions[2] = "SQLAllocEnv";
            sFunctions[3] = "SQLAllocStmt";
            sFunctions[4] = "SQLBindCol";
            sFunctions[5] = "SQLBindParameter";
            sFunctions[6] = "SQLBrowseConnect";
            sFunctions[7] = "SQLCancel";
            sFunctions[8] = "SQLColAttributes";
            sFunctions[9] = "SQLColumnPrivileges";
            sFunctions[10] = "SQLColumns";
            sFunctions[11] = "SQLConnect";
            sFunctions[12] = "SQLDataSources";
            sFunctions[13] = "SQLDescribeCol";
            sFunctions[14] = "SQLDescribeParam";
            sFunctions[15] = "SQLDisconnect";
            sFunctions[16] = "SQLDriverConnect";
            sFunctions[17] = "SQLDrivers";
            sFunctions[18] = "SQLError";
            sFunctions[19] = "SQLExecDirect";
            sFunctions[20] = "SQLExecute";
            sFunctions[21] = "SQLExtendedFetch";
            sFunctions[22] = "SQLFetch";
            sFunctions[23] = "SQLForeignKeys";
            sFunctions[24] = "SQLFreeConnect";
            sFunctions[25] = "SQLFreeEnv";
            sFunctions[26] = "SQLFreeStmt";
            sFunctions[27] = "SQLGetConnectOption";
            sFunctions[28] = "SQLGetCursorName";
            sFunctions[29] = "SQLGetData";
            sFunctions[30] = "SQLGetFunctions";
            sFunctions[31] = "SQLGetInfo";
            sFunctions[32] = "SQLGetStmtOption";
            sFunctions[33] = "SQLGetTypeInfo";
            sFunctions[34] = "SQLMoreResults";
            sFunctions[35] = "SQLNativeSql";
            sFunctions[36] = "SQLNumParams";
            sFunctions[37] = "SQLNumResultCols";
            sFunctions[38] = "SQLParamData";
            sFunctions[39] = "SQLParamOptions";
            sFunctions[40] = "SQLPrepare";
            sFunctions[41] = "SQLPrimaryKeys";
            sFunctions[42] = "SQLProcedureColumns";
            sFunctions[43] = "SQLProcedures";
            sFunctions[44] = "SQLPutData";
            sFunctions[45] = "SQLRowCount";
            sFunctions[46] = "SQLSetConnectOption";
            sFunctions[47] = "SQLSetCursorName";
            sFunctions[48] = "SQLSetParam";
            sFunctions[49] = "SQLSetPos";
            sFunctions[50] = "SQLSetScrollOptions";
            sFunctions[51] = "SQLSetStmtOption";
            sFunctions[52] = "SQLSpecialColumns";
            sFunctions[53] = "SQLStatistics";
            sFunctions[54] = "SQLTablePrivileges";
            sFunctions[55] = "SQLTables";
            sFunctions[56] = "SQLTransact";

            nFunctions[(int)ODBCconst.SQL_API_SQLALLOCCONNECT] = 1;
            nFunctions[(int)ODBCconst.SQL_API_SQLALLOCENV] = 2;
            nFunctions[(int)ODBCconst.SQL_API_SQLALLOCSTMT] = 3;
            nFunctions[(int)ODBCconst.SQL_API_SQLBINDCOL] = 4;
            nFunctions[(int)ODBCconst.SQL_API_SQLBINDPARAMETER] = 5;
            nFunctions[(int)ODBCconst.SQL_API_SQLBROWSECONNECT] = 6;
            nFunctions[(int)ODBCconst.SQL_API_SQLCANCEL] = 7;
            nFunctions[(int)ODBCconst.SQL_API_SQLCOLATTRIBUTES] = 8;
            nFunctions[(int)ODBCconst.SQL_API_SQLCOLUMNPRIVILEGES] = 9;
            nFunctions[(int)ODBCconst.SQL_API_SQLCOLUMNS] = 10;
            nFunctions[(int)ODBCconst.SQL_API_SQLCONNECT] = 11;
            nFunctions[(int)ODBCconst.SQL_API_SQLDATASOURCES] = 12;
            nFunctions[(int)ODBCconst.SQL_API_SQLDESCRIBECOL] = 13;
            nFunctions[(int)ODBCconst.SQL_API_SQLDESCRIBEPARAM] = 14;
            nFunctions[(int)ODBCconst.SQL_API_SQLDISCONNECT] = 15;
            nFunctions[(int)ODBCconst.SQL_API_SQLDRIVERCONNECT] = 16;
            nFunctions[(int)ODBCconst.SQL_API_SQLDRIVERS] = 17;
            nFunctions[(int)ODBCconst.SQL_API_SQLERROR] = 18;
            nFunctions[(int)ODBCconst.SQL_API_SQLEXECDIRECT] = 19;
            nFunctions[(int)ODBCconst.SQL_API_SQLEXECUTE] = 20;
            nFunctions[(int)ODBCconst.SQL_API_SQLEXTENDEDFETCH] = 21;
            nFunctions[(int)ODBCconst.SQL_API_SQLFETCH] = 22;
            nFunctions[(int)ODBCconst.SQL_API_SQLFOREIGNKEYS] = 23;
            nFunctions[(int)ODBCconst.SQL_API_SQLFREECONNECT] = 24;
            nFunctions[(int)ODBCconst.SQL_API_SQLFREEENV] = 25;
            nFunctions[(int)ODBCconst.SQL_API_SQLFREESTMT] = 26;
            nFunctions[(int)ODBCconst.SQL_API_SQLGETCONNECTOPTION] = 27;
            nFunctions[(int)ODBCconst.SQL_API_SQLGETCURSORNAME] = 28;
            nFunctions[(int)ODBCconst.SQL_API_SQLGETDATA] = 29;
            nFunctions[(int)ODBCconst.SQL_API_SQLGETFUNCTIONS] = 30;
            nFunctions[(int)ODBCconst.SQL_API_SQLGETINFO] = 31;
            nFunctions[(int)ODBCconst.SQL_API_SQLGETSTMTOPTION] = 32;
            nFunctions[(int)ODBCconst.SQL_API_SQLGETTYPEINFO] = 33;
            nFunctions[(int)ODBCconst.SQL_API_SQLMORERESULTS] = 34;
            nFunctions[(int)ODBCconst.SQL_API_SQLNATIVESQL] = 35;
            nFunctions[(int)ODBCconst.SQL_API_SQLNUMPARAMS] = 36;
            nFunctions[(int)ODBCconst.SQL_API_SQLNUMRESULTCOLS] = 37;
            nFunctions[(int)ODBCconst.SQL_API_SQLPARAMDATA] = 38;
            nFunctions[(int)ODBCconst.SQL_API_SQLPARAMOPTIONS] = 39;
            nFunctions[(int)ODBCconst.SQL_API_SQLPREPARE] = 40;
            nFunctions[(int)ODBCconst.SQL_API_SQLPRIMARYKEYS] = 41;
            nFunctions[(int)ODBCconst.SQL_API_SQLPROCEDURECOLUMNS] = 42;
            nFunctions[(int)ODBCconst.SQL_API_SQLPROCEDURES] = 43;
            nFunctions[(int)ODBCconst.SQL_API_SQLPUTDATA] = 44;
            nFunctions[(int)ODBCconst.SQL_API_SQLROWCOUNT] = 45;
            nFunctions[(int)ODBCconst.SQL_API_SQLSETCONNECTOPTION] = 46;
            nFunctions[(int)ODBCconst.SQL_API_SQLSETCURSORNAME] = 47;
            nFunctions[(int)ODBCconst.SQL_API_SQLSETPARAM] = 48;
            nFunctions[(int)ODBCconst.SQL_API_SQLSETPOS] = 49;
            nFunctions[(int)ODBCconst.SQL_API_SQLSETSCROLLOPTIONS] = 50;
            nFunctions[(int)ODBCconst.SQL_API_SQLSETSTMTOPTION] = 51;
            nFunctions[(int)ODBCconst.SQL_API_SQLSPECIALCOLUMNS] = 52;
            nFunctions[(int)ODBCconst.SQL_API_SQLSTATISTICS] = 53;
            nFunctions[(int)ODBCconst.SQL_API_SQLTABLEPRIVILEGES] = 54;
            nFunctions[(int)ODBCconst.SQL_API_SQLTABLES] = 55;
            nFunctions[(int)ODBCconst.SQL_API_SQLTRANSACT] = 56;

            sInformation[1] = "ACCESSIBLE_PROCEDURES";
            sInformation[2] = "ACCESSIBLE_TABLES";
            sInformation[3] = "ACTIVE_CONNECTIONS";
            sInformation[4] = "ACTIVE_STATEMENTS";
            sInformation[5] = "ALTER_TABLE";
            sInformation[6] = "BOOKMARK_PERSISTENCE";
            sInformation[7] = "COLUMN_ALIAS";
            sInformation[8] = "CONCAT_NULL_BEHAVIOR";
            sInformation[9] = "CONVERT_BIGINT";
            sInformation[10] = "CONVERT_BINARY";
            sInformation[11] = "CONVERT_BIT";
            sInformation[12] = "CONVERT_CHAR";
            sInformation[13] = "CONVERT_DATE";
            sInformation[14] = "CONVERT_DECIMAL";
            sInformation[15] = "CONVERT_DOUBLE";
            sInformation[16] = "CONVERT_FLOAT";
            sInformation[17] = "CONVERT_FUNCTIONS";
            sInformation[18] = "CONVERT_INTEGER";
            sInformation[19] = "CONVERT_LONGVARBINARY";
            sInformation[20] = "CONVERT_LONGVARCHAR";
            sInformation[21] = "CONVERT_NUMERIC";
            sInformation[22] = "CONVERT_REAL";
            sInformation[23] = "CONVERT_SMALLINT";
            sInformation[24] = "CONVERT_TIME";
            sInformation[25] = "CONVERT_TIMESTAMP";
            sInformation[26] = "CONVERT_TINYINT";
            sInformation[27] = "CONVERT_VARBINARY";
            sInformation[28] = "CONVERT_VARCHAR";
            sInformation[29] = "CORRELATION_NAME";
            sInformation[30] = "CURSOR_COMMIT_BEHAVIOR";
            sInformation[31] = "CURSOR_ROLLBACK_BEHAVIOR";
            sInformation[32] = "DATA_SOURCE_NAME";
            sInformation[33] = "DATA_SOURCE_READ_ONLY";
            sInformation[34] = "DBMS_NAME";
            sInformation[35] = "DBMS_VER";
            sInformation[36] = "DEFAULT_TXN_ISOLATION";
            sInformation[37] = "DRIVER_HDBC";
            sInformation[38] = "DRIVER_HENV";
            sInformation[39] = "DRIVER_HLIB";
            sInformation[40] = "DRIVER_HSTMT";
            sInformation[41] = "DRIVER_NAME";
            sInformation[42] = "DRIVER_ODBC_VER";
            sInformation[43] = "DRIVER_VER";
            sInformation[44] = "EXPRESSIONS_IN_ORDERBY";
            sInformation[45] = "FETCH_DIRECTION";
            sInformation[46] = "FILE_USAGE";
            sInformation[47] = "GETDATA_EXTENSIONS";
            sInformation[48] = "GROUP_BY";
            sInformation[49] = "IDENTIFIER_CASE";
            sInformation[50] = "IDENTIFIER_QUOTE_CHAR";
            sInformation[51] = "KEYWORDS";
            sInformation[52] = "LIKE_ESCAPE_CLAUSE";
            sInformation[53] = "LOCK_TYPES";
            sInformation[54] = "MAX_BINARY_LITERAL_LEN";
            sInformation[55] = "MAX_CHAR_LITERAL_LEN";
            sInformation[56] = "MAX_COLUMNS_IN_GROUP_BY";
            sInformation[57] = "MAX_COLUMNS_IN_INDEX";
            sInformation[58] = "MAX_COLUMNS_IN_ORDER_BY";
            sInformation[59] = "MAX_COLUMNS_IN_SELECT";
            sInformation[60] = "MAX_COLUMNS_IN_TABLE";
            sInformation[61] = "MAX_COLUMN_NAME_LEN";
            sInformation[62] = "MAX_CURSOR_NAME_LEN";
            sInformation[63] = "MAX_INDEX_SIZE";
            sInformation[64] = "MAX_OWNER_NAME_LEN";
            sInformation[65] = "MAX_PROCEDURE_NAME_LEN";
            sInformation[66] = "MAX_QUALIFIER_NAME_LEN";
            sInformation[67] = "MAX_ROW_SIZE";
            sInformation[68] = "MAX_ROW_SIZE_INCLUDES_LONG";
            sInformation[69] = "MAX_STATEMENT_LEN";
            sInformation[70] = "MAX_TABLES_IN_SELECT";
            sInformation[71] = "MAX_TABLE_NAME_LEN";
            sInformation[72] = "MAX_USER_NAME_LEN";
            sInformation[73] = "MULTIPLE_ACTIVE_TXN";
            sInformation[74] = "MULT_RESULT_SETS";
            sInformation[75] = "NEED_LONG_DATA_LEN";
            sInformation[76] = "NON_NULLABLE_COLUMNS";
            sInformation[77] = "NULL_COLLATION";
            sInformation[78] = "NUMERIC_FUNCTIONS";
            sInformation[79] = "ODBC_API_CONFORMANCE";
            sInformation[80] = "ODBC_SAG_CLI_CONFORMANCE";
            sInformation[81] = "ODBC_SQL_CONFORMANCE";
            sInformation[82] = "ODBC_SQL_OPT_IEF";
            sInformation[83] = "ODBC_VER";
            sInformation[84] = "ORDER_BY_COLUMNS_IN_SELECT";
            sInformation[85] = "OUTER_JOINS";
            sInformation[86] = "OWNER_TERM";
            sInformation[87] = "OWNER_USAGE";
            sInformation[88] = "POSITIONED_STATEMENTS";
            sInformation[89] = "POS_OPERATIONS";
            sInformation[90] = "PROCEDURES";
            sInformation[91] = "PROCEDURE_TERM";
            sInformation[92] = "QUALIFIER_LOCATION";
            sInformation[93] = "QUALIFIER_NAME_SEPARATOR";
            sInformation[94] = "QUALIFIER_TERM";
            sInformation[95] = "QUALIFIER_USAGE";
            sInformation[96] = "QUOTED_IDENTIFIER_CASE";
            sInformation[97] = "ROW_UPDATES";
            sInformation[98] = "SCROLL_CONCURRENCY";
            sInformation[99] = "SCROLL_OPTIONS";
            sInformation[100] = "SEARCH_PATTERN_ESCAPE";
            sInformation[101] = "SERVER_NAME";
            sInformation[102] = "SPECIAL_CHARACTERS";
            sInformation[103] = "STATIC_SENSITIVITY";
            sInformation[104] = "STRING_FUNCTIONS";
            sInformation[105] = "SUBQUERIES";
            sInformation[106] = "SYSTEM_FUNCTIONS";
            sInformation[107] = "TABLE_TERM";
            sInformation[108] = "TIMEDATE_ADD_INTERVALS";
            sInformation[109] = "TIMEDATE_DIFF_INTERVALS";
            sInformation[110] = "TIMEDATE_FUNCTIONS";
            sInformation[111] = "TXN_CAPABLE";
            sInformation[112] = "TXN_ISOLATION_OPTION";
            sInformation[113] = "UNION";
            sInformation[114] = "USER_NAME";

            nInformation[(int)ODBCconst.SQL_ACCESSIBLE_PROCEDURES] = 1;
            nInformation[(int)ODBCconst.SQL_ACCESSIBLE_TABLES] = 2;
            nInformation[(int)ODBCconst.SQL_ACTIVE_CONNECTIONS] = 3;
            nInformation[(int)ODBCconst.SQL_ACTIVE_STATEMENTS] = 4;
            nInformation[(int)ODBCconst.SQL_ALTER_TABLE] = 5;
            nInformation[(int)ODBCconst.SQL_BOOKMARK_PERSISTENCE] = 6;
            nInformation[(int)ODBCconst.SQL_COLUMN_ALIAS] = 7;
            nInformation[(int)ODBCconst.SQL_CONCAT_NULL_BEHAVIOR] = 8;
            nInformation[(int)ODBCconst.SQL_CONVERT_BIGINT] = 9;
            nInformation[(int)ODBCconst.SQL_CONVERT_BINARY] = 10;
            nInformation[(int)ODBCconst.SQL_CONVERT_BIT] = 11;
            nInformation[(int)ODBCconst.SQL_CONVERT_CHAR] = 12;
            nInformation[(int)ODBCconst.SQL_CONVERT_DATE] = 13;
            nInformation[(int)ODBCconst.SQL_CONVERT_DECIMAL] = 14;
            nInformation[(int)ODBCconst.SQL_CONVERT_DOUBLE] = 15;
            nInformation[(int)ODBCconst.SQL_CONVERT_FLOAT] = 16;
            nInformation[(int)ODBCconst.SQL_CONVERT_FUNCTIONS] = 17;
            nInformation[(int)ODBCconst.SQL_CONVERT_INTEGER] = 18;
            nInformation[(int)ODBCconst.SQL_CONVERT_LONGVARBINARY] = 19;
            nInformation[(int)ODBCconst.SQL_CONVERT_LONGVARCHAR] = 20;
            nInformation[(int)ODBCconst.SQL_CONVERT_NUMERIC] = 21;
            nInformation[(int)ODBCconst.SQL_CONVERT_REAL] = 22;
            nInformation[(int)ODBCconst.SQL_CONVERT_SMALLINT] = 23;
            nInformation[(int)ODBCconst.SQL_CONVERT_TIME] = 24;
            nInformation[(int)ODBCconst.SQL_CONVERT_TIMESTAMP] = 25;
            nInformation[(int)ODBCconst.SQL_CONVERT_TINYINT] = 26;
            nInformation[(int)ODBCconst.SQL_CONVERT_VARBINARY] = 27;
            nInformation[(int)ODBCconst.SQL_CONVERT_VARCHAR] = 28;
            nInformation[(int)ODBCconst.SQL_CORRELATION_NAME] = 29;
            nInformation[(int)ODBCconst.SQL_CURSOR_COMMIT_BEHAVIOR] = 30;
            nInformation[(int)ODBCconst.SQL_CURSOR_ROLLBACK_BEHAVIOR] = 31;
            nInformation[(int)ODBCconst.SQL_DATA_SOURCE_NAME] = 32;
            nInformation[(int)ODBCconst.SQL_DATA_SOURCE_READ_ONLY] = 33;
            nInformation[(int)ODBCconst.SQL_DBMS_NAME] = 34;
            nInformation[(int)ODBCconst.SQL_DBMS_VER] = 35;
            nInformation[(int)ODBCconst.SQL_DEFAULT_TXN_ISOLATION] = 36;
            nInformation[(int)ODBCconst.SQL_DRIVER_HDBC] = 37;
            nInformation[(int)ODBCconst.SQL_DRIVER_HENV] = 38;
            nInformation[(int)ODBCconst.SQL_DRIVER_HLIB] = 39;
            nInformation[(int)ODBCconst.SQL_DRIVER_HSTMT] = 40;
            nInformation[(int)ODBCconst.SQL_DRIVER_NAME] = 41;
            nInformation[(int)ODBCconst.SQL_DRIVER_ODBC_VER] = 42;
            nInformation[(int)ODBCconst.SQL_DRIVER_VER] = 43;
            nInformation[(int)ODBCconst.SQL_EXPRESSIONS_IN_ORDERBY] = 44;
            nInformation[(int)ODBCconst.SQL_FETCH_DIRECTION] = 45;
            nInformation[(int)ODBCconst.SQL_FILE_USAGE] = 46;
            nInformation[(int)ODBCconst.SQL_GETDATA_EXTENSIONS] = 47;
            nInformation[(int)ODBCconst.SQL_GROUP_BY] = 48;
            nInformation[(int)ODBCconst.SQL_IDENTIFIER_CASE] = 49;
            nInformation[(int)ODBCconst.SQL_IDENTIFIER_QUOTE_CHAR] = 50;
            nInformation[(int)ODBCconst.SQL_KEYWORDS] = 51;
            nInformation[(int)ODBCconst.SQL_LIKE_ESCAPE_CLAUSE] = 52;
            nInformation[(int)ODBCconst.SQL_LOCK_TYPES] = 53;
            nInformation[(int)ODBCconst.SQL_MAX_BINARY_LITERAL_LEN] = 54;
            nInformation[(int)ODBCconst.SQL_MAX_CHAR_LITERAL_LEN] = 55;
            nInformation[(int)ODBCconst.SQL_MAX_COLUMNS_IN_GROUP_BY] = 56;
            nInformation[(int)ODBCconst.SQL_MAX_COLUMNS_IN_INDEX] = 57;
            nInformation[(int)ODBCconst.SQL_MAX_COLUMNS_IN_ORDER_BY] = 58;
            nInformation[(int)ODBCconst.SQL_MAX_COLUMNS_IN_SELECT] = 59;
            nInformation[(int)ODBCconst.SQL_MAX_COLUMNS_IN_TABLE] = 60;
            nInformation[(int)ODBCconst.SQL_MAX_COLUMN_NAME_LEN] = 61;
            nInformation[(int)ODBCconst.SQL_MAX_CURSOR_NAME_LEN] = 62;
            nInformation[(int)ODBCconst.SQL_MAX_INDEX_SIZE] = 63;
            nInformation[(int)ODBCconst.SQL_MAX_OWNER_NAME_LEN] = 64;
            nInformation[(int)ODBCconst.SQL_MAX_PROCEDURE_NAME_LEN] = 65;
            nInformation[(int)ODBCconst.SQL_MAX_QUALIFIER_NAME_LEN] = 66;
            nInformation[(int)ODBCconst.SQL_MAX_ROW_SIZE] = 67;
            nInformation[(int)ODBCconst.SQL_MAX_ROW_SIZE_INCLUDES_LONG] = 68;
            nInformation[(int)ODBCconst.SQL_MAX_STATEMENT_LEN] = 69;
            nInformation[(int)ODBCconst.SQL_MAX_TABLES_IN_SELECT] = 70;
            nInformation[(int)ODBCconst.SQL_MAX_TABLE_NAME_LEN] = 71;
            nInformation[(int)ODBCconst.SQL_MAX_USER_NAME_LEN] = 72;
            nInformation[(int)ODBCconst.SQL_MULTIPLE_ACTIVE_TXN] = 73;
            nInformation[(int)ODBCconst.SQL_MULT_RESULT_SETS] = 74;
            nInformation[(int)ODBCconst.SQL_NEED_LONG_DATA_LEN] = 75;
            nInformation[(int)ODBCconst.SQL_NON_NULLABLE_COLUMNS] = 76;
            nInformation[(int)ODBCconst.SQL_NULL_COLLATION] = 77;
            nInformation[(int)ODBCconst.SQL_NUMERIC_FUNCTIONS] = 78;
            nInformation[(int)ODBCconst.SQL_ODBC_API_CONFORMANCE] = 79;
            nInformation[(int)ODBCconst.SQL_ODBC_SAG_CLI_CONFORMANCE] = 80;
            nInformation[(int)ODBCconst.SQL_ODBC_SQL_CONFORMANCE] = 81;
            nInformation[(int)ODBCconst.SQL_ODBC_SQL_OPT_IEF] = 82;
            nInformation[(int)ODBCconst.SQL_ODBC_VER] = 83;
            nInformation[(int)ODBCconst.SQL_ORDER_BY_COLUMNS_IN_SELECT] = 84;
            nInformation[(int)ODBCconst.SQL_OUTER_JOINS] = 85;
            nInformation[(int)ODBCconst.SQL_OWNER_TERM] = 86;
            nInformation[(int)ODBCconst.SQL_OWNER_USAGE] = 87;
            nInformation[(int)ODBCconst.SQL_POSITIONED_STATEMENTS] = 88;
            nInformation[(int)ODBCconst.SQL_POS_OPERATIONS] = 89;
            nInformation[(int)ODBCconst.SQL_PROCEDURES] = 90;
            nInformation[(int)ODBCconst.SQL_PROCEDURE_TERM] = 91;
            nInformation[(int)ODBCconst.SQL_QUALIFIER_LOCATION] = 92;
            nInformation[(int)ODBCconst.SQL_QUALIFIER_NAME_SEPARATOR] = 93;
            nInformation[(int)ODBCconst.SQL_QUALIFIER_TERM] = 94;
            nInformation[(int)ODBCconst.SQL_QUALIFIER_USAGE] = 95;
            nInformation[(int)ODBCconst.SQL_QUOTED_IDENTIFIER_CASE] = 96;
            nInformation[(int)ODBCconst.SQL_ROW_UPDATES] = 97;
            nInformation[(int)ODBCconst.SQL_SCROLL_CONCURRENCY] = 98;
            nInformation[(int)ODBCconst.SQL_SCROLL_OPTIONS] = 99;
            nInformation[(int)ODBCconst.SQL_SEARCH_PATTERN_ESCAPE] = 100;
            nInformation[(int)ODBCconst.SQL_SERVER_NAME] = 101;
            nInformation[(int)ODBCconst.SQL_SPECIAL_CHARACTERS] = 102;
            nInformation[(int)ODBCconst.SQL_STATIC_SENSITIVITY] = 103;
            nInformation[(int)ODBCconst.SQL_STRING_FUNCTIONS] = 104;
            nInformation[(int)ODBCconst.SQL_SUBQUERIES] = 105;
            nInformation[(int)ODBCconst.SQL_SYSTEM_FUNCTIONS] = 106;
            nInformation[(int)ODBCconst.SQL_TABLE_TERM] = 107;
            nInformation[(int)ODBCconst.SQL_TIMEDATE_ADD_INTERVALS] = 108;
            nInformation[(int)ODBCconst.SQL_TIMEDATE_DIFF_INTERVALS] = 109;
            nInformation[(int)ODBCconst.SQL_TIMEDATE_FUNCTIONS] = 110;
            nInformation[(int)ODBCconst.SQL_TXN_CAPABLE] = 111;
            nInformation[(int)ODBCconst.SQL_TXN_ISOLATION_OPTION] = 112;
            nInformation[(int)ODBCconst.SQL_UNION] = 113;
            nInformation[(int)ODBCconst.SQL_USER_NAME] = 114;
        }
        public static clsODBCReferences Instance
        {
            get
            {
                return _instance;
            }
        }
    }
}
